﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Xml;
using C1.Win.C1FlexGrid;

namespace FlexAccordion
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            //Initialize Accordion Styles
            CellStyle csHeader = flexAccordion1.HeaderStyle;
            csHeader.ForeColor = Color.White;
            csHeader.TextEffect = TextEffectEnum.Raised;
            csHeader.BackColor = Color.Green;
            csHeader.BackgroundImageLayout = ImageAlignEnum.TileStretch;
            csHeader.ImageSpacing = 5;
            csHeader.Border.Width = 0;
            csHeader.Margins = new System.Drawing.Printing.Margins(5, 0, 0, 0);
            csHeader.Font = new Font(flexAccordion1.Font, FontStyle.Bold);
            
            CellStyle csItem = flexAccordion1.ItemStyle;
            csItem.BackColor = Color.DarkGreen;
            csItem.ForeColor = Color.White;
            csItem.Border.Style = BorderStyleEnum.None;
            csItem.TextEffect = TextEffectEnum.Raised;
            csItem.Margins = new System.Drawing.Printing.Margins(25, 0, 0, 0);
            flexAccordion1.Styles["Highlight"].BackColor = Color.FromArgb(202, 228, 195);
            flexAccordion1.Styles["Highlight"].ForeColor = Color.FromArgb(28, 74, 26);

            //Adjust some FlexAccordion properties specific to this demo
            flexAccordion1.Padding = new Padding(10, 0, 0, 0);
            flexAccordion1.Rows.DefaultSize = 23;

            //Create an XmlReader to begin parsing our xml
            XmlReader xr = XmlReader.Create("C1Controls.xml");

            Row headerRow = null;
            Row itemRow = null;
            while (xr.Read())
            {
                if (xr.NodeType == XmlNodeType.Element)
                {
                    switch (xr.Name)
                    {
                        case "control":
                            headerRow = flexAccordion1.AddItem(xr.GetAttribute("name"));
                            headerRow.Style = csHeader;
                            headerRow.IsNode = true;
                            if (!string.IsNullOrEmpty(xr.GetAttribute("icon")))
                            {
                                //add an icon to the header
                                flexAccordion1.SetCellImage(headerRow.Index, 0, imageList1.Images[xr.GetAttribute("iconindex")]);
                                headerRow.ImageAlign = ImageAlignEnum.LeftCenter;

                            }
                            break;
                        case "sample":
                            itemRow = flexAccordion1.AddItem(xr.GetAttribute("name"));
                            itemRow.Style = csItem;
                            itemRow.UserData = xr.GetAttribute("form");
                            itemRow.Visible = false;
                            break;
                    }
                }
            }

        }
  
        // update groupBox to show selected item UserData
        private void flexAccordion1_MouseClick(object sender, MouseEventArgs e)
        {
            if (flexAccordion1.MouseRow != -1)
            {
                Row hitRow = flexAccordion1.Rows[flexAccordion1.MouseRow];
                if (!hitRow.IsNode)
                {
                    groupBox1.Text = hitRow.UserData.ToString();
                }
            }
        }

    }

}
